SDL_sensor.c File Reference
`#include "../SDL_internal.h"`
`#include "SDL.h"`
`#include "SDL_atomic.h"`
`#include "SDL_events.h"`
`#include "SDL_syssensor.h"`
`#include "SDL_assert.h"`
`#include "../events/SDL_events_c.h"`
Include dependency graph for SDL_sensor.c:

Go to the source code of this file.

## Functions

static void | SDL_LockSensors (void)
static void | SDL_UnlockSensors (void)
int | SDL_SensorInit (void)
int | SDL_NumSensors (void)
| Count the number of sensors attached to the system right now. More...
SDL_SensorID | SDL_GetNextSensorInstanceID ()
static SDL_bool | SDL_GetDriverAndSensorIndex (int device_index, SDL_SensorDriver **driver, int *driver_index)
const char * | SDL_SensorGetDeviceName (int device_index)
| Get the implementation dependent name of a sensor. More...
SDL_SensorType | SDL_SensorGetDeviceType (int device_index)
| Get the type of a sensor. More...
SDL_SensorType | SDL_SensorGetDeviceNonPortableType (int device_index)
| Get the platform dependent type of a sensor. More...
SDL_SensorID | SDL_SensorGetDeviceInstanceID (int device_index)
| Get the instance ID of a sensor. More...
SDL_Sensor * | SDL_SensorOpen (int device_index)
| Open a sensor for use. More...
SDL_Sensor * | SDL_SensorFromInstanceID (SDL_SensorID instance_id)
static int | SDL_PrivateSensorValid (SDL_Sensor *sensor)
const char * | SDL_SensorGetName (SDL_Sensor *sensor)
| Get the implementation dependent name of a sensor. More...
SDL_SensorType | SDL_SensorGetType (SDL_Sensor *sensor)
| Get the type of a sensor. More...
int | SDL_SensorGetNonPortableType (SDL_Sensor *sensor)
| Get the platform dependent type of a sensor. More...
SDL_SensorID | SDL_SensorGetInstanceID (SDL_Sensor *sensor)
| Get the instance ID of a sensor. More...
int | SDL_SensorGetData (SDL_Sensor *sensor, float *data, int num_values)
void | SDL_SensorClose (SDL_Sensor *sensor)
void | SDL_SensorQuit (void)
int | SDL_PrivateSensorUpdate (SDL_Sensor *sensor, float *data, int num_values)
void | SDL_SensorUpdate (void)

## Variables

static SDL_SensorDriver * | SDL_sensor_drivers []
static SDL_Sensor * | SDL_sensors = NULL
static SDL_bool | SDL_updating_sensor = SDL_FALSE
static SDL_mutex * | SDL_sensor_lock = NULL
static SDL_atomic_t | SDL_next_sensor_instance_id

## Function Documentation

## SDL_GetDriverAndSensorIndex()

static SDL_bool SDL_GetDriverAndSensorIndex | ( | int | device_index,
|  | SDL_SensorDriver ** | driver,
|  | int * | driver_index
| ) |  |

static

Definition at line 122 of file SDL_sensor.c.

{
int i, num_sensors, total_sensors = 0;
if (device_index >= 0) {
for (i = 0; i < SDL_arraysize(SDL_sensor_drivers); ++i) {
num_sensors = SDL_sensor_drivers[i]->GetCount();
if (device_index < num_sensors) {
*driver = SDL_sensor_drivers[i];
*driver_index = device_index;
return SDL_TRUE;
}
device_index -= num_sensors;
total_sensors += num_sensors;
}
}
SDL_SetError("There are %d sensors available", total_sensors);
return SDL_FALSE;
}

References i, SDL_arraysize, SDL_FALSE, SDL_sensor_drivers, SDL_SetError, and SDL_TRUE.

Referenced by SDL_SensorGetDeviceInstanceID(), SDL_SensorGetDeviceName(), SDL_SensorGetDeviceNonPortableType(), SDL_SensorGetDeviceType(), and SDL_SensorOpen().

## SDL_GetNextSensorInstanceID()

SDL_SensorID SDL_GetNextSensorInstanceID | ( |  | ) |

Definition at line 112 of file SDL_sensor.c.

{
return SDL_AtomicIncRef(&SDL_next_sensor_instance_id);
}

References SDL_AtomicIncRef, and SDL_next_sensor_instance_id.

## SDL_LockSensors()

static void SDL_LockSensors | ( | void |  | ) |

static

Definition at line 52 of file SDL_sensor.c.

{
if (SDL_sensor_lock) {
SDL_LockMutex(SDL_sensor_lock);
}
}

References SDL_LockMutex, and SDL_sensor_lock.

Referenced by SDL_NumSensors(), SDL_SensorClose(), SDL_SensorFromInstanceID(), SDL_SensorGetDeviceInstanceID(), SDL_SensorGetDeviceName(), SDL_SensorGetDeviceNonPortableType(), SDL_SensorGetDeviceType(), SDL_SensorOpen(), SDL_SensorQuit(), and SDL_SensorUpdate().

## SDL_NumSensors()

int SDL_NumSensors | ( | void |  | ) |

Count the number of sensors attached to the system right now.

Gyroscope sensor

The gyroscope returns the current rate of rotation in radians per second. The rotation is positive in the counter-clockwise direction. That is, an observer looking from a positive location on one of the axes would see positive rotation on that axis when it appeared to be rotating counter-clockwise.

values[0]: Angular speed around the x axis values[1]: Angular speed around the y axis values[2]: Angular speed around the z axis

For phones held in portrait mode, the axes are defined as follows: -X ... +X : left ... right -Y ... +Y : bottom ... top -Z ... +Z : farther ... closer

The axis data is not changed when the phone is rotated.

See also
  SDL_GetDisplayOrientation()

Definition at line 97 of file SDL_sensor.c.

{
int i, total_sensors = 0;
SDL_LockSensors();
for (i = 0; i < SDL_arraysize(SDL_sensor_drivers); ++i) {
total_sensors += SDL_sensor_drivers[i]->GetCount();
}
SDL_UnlockSensors();
return total_sensors;
}

References i, SDL_arraysize, SDL_LockSensors(), SDL_sensor_drivers, and SDL_UnlockSensors().

## SDL_PrivateSensorUpdate()

int SDL_PrivateSensorUpdate | ( | SDL_Sensor * | sensor,
|  | float * | data,
|  | int | num_values
| ) |  |

Definition at line 476 of file SDL_sensor.c.

{
int posted;
/* Allow duplicate events, for things like steps and heartbeats */
/* Update internal sensor state */
num_values = SDL_min(num_values, SDL_arraysize(sensor->data));
SDL_memcpy(sensor->data, data, num_values*sizeof(*data));
/* Post the event, if desired */
posted = 0;
#if !SDL_EVENTS_DISABLED
if (SDL_GetEventState(SDL_JOYAXISMOTION) == SDL_ENABLE) {
SDL_Event event;
event.type = SDL_SENSORUPDATE;
event.sensor.which = sensor->instance_id;
num_values = SDL_min(num_values, SDL_arraysize(event.sensor.data));
SDL_memset(event.sensor.data, 0, sizeof(event.sensor.data));
SDL_memcpy(event.sensor.data, data, num_values*sizeof(*data));
posted = SDL_PushEvent(&event) == 1;
}
#endif /* !SDL_EVENTS_DISABLED */
return posted;
}

References SDL_arraysize, SDL_ENABLE, SDL_GetEventState, SDL_JOYAXISMOTION, SDL_memcpy, SDL_memset, SDL_min, SDL_PushEvent, and SDL_SENSORUPDATE.

## SDL_PrivateSensorValid()

static int SDL_PrivateSensorValid | ( | SDL_Sensor * | sensor | ) |

static

Definition at line 305 of file SDL_sensor.c.

{
int valid;
if (sensor == NULL) {
SDL_SetError("Sensor hasn't been opened yet");
valid = 0;
} else {
valid = 1;
}
return valid;
}

References NULL, and SDL_SetError.

Referenced by SDL_SensorClose(), SDL_SensorGetData(), SDL_SensorGetInstanceID(), SDL_SensorGetName(), SDL_SensorGetNonPortableType(), and SDL_SensorGetType().

## SDL_SensorClose()

void SDL_SensorClose | ( | SDL_Sensor * | sensor | ) |

Close a sensor previously opened with SDL_SensorOpen()

Definition at line 390 of file SDL_sensor.c.

{
SDL_Sensor *sensorlist;
SDL_Sensor *sensorlistprev;
if (!SDL_PrivateSensorValid(sensor)) {
return;
}
SDL_LockSensors();
/* First decrement ref count */
if (--sensor->ref_count > 0) {
SDL_UnlockSensors();
return;
}
if (SDL_updating_sensor) {
SDL_UnlockSensors();
return;
}
sensor->driver->Close(sensor);
sensor->hwdata = NULL;
sensorlist = SDL_sensors;
sensorlistprev = NULL;
while (sensorlist) {
if (sensor == sensorlist) {
if (sensorlistprev) {
/* unlink this entry */
sensorlistprev->next = sensorlist->next;
} else {
SDL_sensors = sensor->next;
}
break;
}
sensorlistprev = sensorlist;
sensorlist = sensorlist->next;
}
SDL_free(sensor->name);
/* Free the data associated with this sensor */
SDL_free(sensor);
SDL_UnlockSensors();
}

References NULL, SDL_free, SDL_LockSensors(), SDL_PrivateSensorValid(), SDL_sensors, SDL_UnlockSensors(), and SDL_updating_sensor.

Referenced by SDL_SensorQuit(), and SDL_SensorUpdate().

## SDL_SensorFromInstanceID()

SDL_Sensor* SDL_SensorFromInstanceID | ( | SDL_SensorID | instance_id | ) |

Return the SDL_Sensor associated with an instance id.

Definition at line 287 of file SDL_sensor.c.

{
SDL_Sensor *sensor;
SDL_LockSensors();
for (sensor = SDL_sensors; sensor; sensor = sensor->next) {
if (sensor->instance_id == instance_id) {
break;
}
}
SDL_UnlockSensors();
return sensor;
}

References SDL_LockSensors(), SDL_sensors, and SDL_UnlockSensors().

## SDL_SensorGetData()

int SDL_SensorGetData | ( | SDL_Sensor * | sensor,
|  | float * | data,
|  | int | num_values
| ) |  |

Get the current state of an opened sensor.

The number of values and interpretation of the data is sensor dependent.

Parameters

  sensor | The sensor to query
  data | A pointer filled with the current sensor state
  num_values | The number of values to write to data

Returns
  0 or -1 if an error occurred.

Definition at line 375 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return -1;
}
num_values = SDL_min(num_values, SDL_arraysize(sensor->data));
SDL_memcpy(data, sensor->data, num_values*sizeof(*data));
return 0;
}

References SDL_arraysize, SDL_memcpy, SDL_min, and SDL_PrivateSensorValid().

## SDL_SensorGetDeviceInstanceID()

SDL_SensorID SDL_SensorGetDeviceInstanceID | ( | int | device_index | ) |

Get the instance ID of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor instance ID, or -1 if device_index is out of range.

Definition at line 193 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
SDL_SensorID instance_id = -1;
SDL_LockSensors();
if (SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
instance_id = driver->GetDeviceInstanceID(device_index);
}
SDL_UnlockSensors();
return instance_id;
}

References SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), and SDL_UnlockSensors().

## SDL_SensorGetDeviceName()

const char* SDL_SensorGetDeviceName | ( | int | device_index | ) |

Get the implementation dependent name of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor name, or NULL if device_index is out of range.

Definition at line 147 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
const char *name = NULL;
SDL_LockSensors();
if (SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
name = driver->GetDeviceName(device_index);
}
SDL_UnlockSensors();
/* FIXME: Really we should reference count this name so it doesn't go away after unlock */
return name;
}

References NULL, SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), and SDL_UnlockSensors().

## SDL_SensorGetDeviceNonPortableType()

SDL_SensorType SDL_SensorGetDeviceNonPortableType | ( | int | device_index | ) |

Get the platform dependent type of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor platform dependent type, or -1 if device_index is out of range.

Definition at line 178 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
int type = -1;
SDL_LockSensors();
if (SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
type = driver->GetDeviceNonPortableType(device_index);
}
SDL_UnlockSensors();
return type;
}

References SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), and SDL_UnlockSensors().

## SDL_SensorGetDeviceType()

SDL_SensorType SDL_SensorGetDeviceType | ( | int | device_index | ) |

Get the type of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor type, or SDL_SENSOR_INVALID if device_index is out of range.

Definition at line 163 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
SDL_SensorType type = SDL_SENSOR_INVALID;
SDL_LockSensors();
if (SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
type = driver->GetDeviceType(device_index);
}
SDL_UnlockSensors();
return type;
}

References SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), SDL_SENSOR_INVALID, and SDL_UnlockSensors().

## SDL_SensorGetInstanceID()

SDL_SensorID SDL_SensorGetInstanceID | ( | SDL_Sensor * | sensor | ) |

Get the instance ID of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor instance ID, or -1 if the sensor is NULL.

Definition at line 362 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return -1;
}
return sensor->instance_id;
}

References SDL_PrivateSensorValid().

## SDL_SensorGetName()

const char* SDL_SensorGetName | ( | SDL_Sensor * | sensor | ) |

Get the implementation dependent name of a sensor.

Returns
  The sensor name, or NULL if the sensor is NULL.

Definition at line 323 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return NULL;
}
return sensor->name;
}

References NULL, and SDL_PrivateSensorValid().

## SDL_SensorGetNonPortableType()

int SDL_SensorGetNonPortableType | ( | SDL_Sensor * | sensor | ) |

Get the platform dependent type of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor platform dependent type, or -1 if the sensor is NULL.

Definition at line 349 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return -1;
}
return sensor->non_portable_type;
}

References SDL_PrivateSensorValid().

## SDL_SensorGetType()

SDL_SensorType SDL_SensorGetType | ( | SDL_Sensor * | sensor | ) |

Get the type of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor type, or SDL_SENSOR_INVALID if the sensor is NULL.

Definition at line 336 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return SDL_SENSOR_INVALID;
}
return sensor->type;
}

References SDL_PrivateSensorValid(), and SDL_SENSOR_INVALID.

## SDL_SensorInit()

int SDL_SensorInit | ( | void |  | ) |

Definition at line 69 of file SDL_sensor.c.

{
int i, status;
/* Create the sensor list lock */
if (!SDL_sensor_lock) {
SDL_sensor_lock = SDL_CreateMutex();
}
#if !SDL_EVENTS_DISABLED
if (SDL_InitSubSystem(SDL_INIT_EVENTS) < 0) {
return -1;
}
#endif /* !SDL_EVENTS_DISABLED */
status = -1;
for (i = 0; i < SDL_arraysize(SDL_sensor_drivers); ++i) {
if (SDL_sensor_drivers[i]->Init() >= 0) {
status = 0;
}
}
return status;
}

References i, SDL_arraysize, SDL_CreateMutex, SDL_INIT_EVENTS, SDL_InitSubSystem, SDL_sensor_drivers, and SDL_sensor_lock.

Referenced by SDL_InitSubSystem().

## SDL_SensorOpen()

SDL_Sensor* SDL_SensorOpen | ( | int | device_index | ) |

Open a sensor for use.

The index passed as an argument refers to the N'th sensor on the system.

Returns
  A sensor identifier, or NULL if an error occurred.

Definition at line 215 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
SDL_SensorID instance_id;
SDL_Sensor *sensor;
SDL_Sensor *sensorlist;
const char *sensorname = NULL;
SDL_LockSensors();
if (!SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
SDL_UnlockSensors();
return NULL;
}
sensorlist = SDL_sensors;
/* If the sensor is already open, return it
* it is important that we have a single sensor * for each instance id
*/
instance_id = driver->GetDeviceInstanceID(device_index);
while (sensorlist) {
if (instance_id == sensorlist->instance_id) {
sensor = sensorlist;
++sensor->ref_count;
SDL_UnlockSensors();
return sensor;
}
sensorlist = sensorlist->next;
}
/* Create and initialize the sensor */
sensor = (SDL_Sensor *) SDL_calloc(sizeof(*sensor), 1);
if (sensor == NULL) {
SDL_OutOfMemory();
SDL_UnlockSensors();
return NULL;
}
sensor->driver = driver;
sensor->instance_id = instance_id;
sensor->type = driver->GetDeviceType(device_index);
sensor->non_portable_type = driver->GetDeviceNonPortableType(device_index);
if (driver->Open(sensor, device_index) < 0) {
SDL_free(sensor);
SDL_UnlockSensors();
return NULL;
}
sensorname = driver->GetDeviceName(device_index);
if (sensorname) {
sensor->name = SDL_strdup(sensorname);
} else {
sensor->name = NULL;
}
/* Add sensor to list */
++sensor->ref_count;
/* Link the sensor in the list */
sensor->next = SDL_sensors;
SDL_sensors = sensor;
SDL_UnlockSensors();
driver->Update(sensor);
return sensor;
}

References NULL, SDL_calloc, SDL_free, SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), SDL_OutOfMemory, SDL_sensors, SDL_strdup, and SDL_UnlockSensors().

## SDL_SensorQuit()

void SDL_SensorQuit | ( | void |  | ) |

Definition at line 440 of file SDL_sensor.c.

{
int i;
/* Make sure we're not getting called in the middle of updating sensors */
SDL_assert(!SDL_updating_sensor);
SDL_LockSensors();
/* Stop the event polling */
while (SDL_sensors) {
SDL_sensors->ref_count = 1;
SDL_SensorClose(SDL_sensors);
}
/* Quit the sensor setup */
for (i = 0; i < SDL_arraysize(SDL_sensor_drivers); ++i) {
SDL_sensor_drivers[i]->Quit();
}
SDL_UnlockSensors();
#if !SDL_EVENTS_DISABLED
SDL_QuitSubSystem(SDL_INIT_EVENTS);
#endif
if (SDL_sensor_lock) {
SDL_DestroyMutex(SDL_sensor_lock);
SDL_sensor_lock = NULL;
}
}

References i, NULL, SDL_arraysize, SDL_assert, SDL_DestroyMutex, SDL_INIT_EVENTS, SDL_LockSensors(), SDL_QuitSubSystem, SDL_sensor_drivers, SDL_sensor_lock, SDL_SensorClose(), SDL_sensors, SDL_UnlockSensors(), and SDL_updating_sensor.

Referenced by SDL_QuitSubSystem().

## SDL_SensorUpdate()

void SDL_SensorUpdate | ( | void |  | ) |

Update the current state of the open sensors.

This is called automatically by the event loop if sensor events are enabled.

This needs to be called from the thread that initialized the sensor subsystem.

Definition at line 503 of file SDL_sensor.c.

{
int i;
SDL_Sensor *sensor;
if (!SDL_WasInit(SDL_INIT_SENSOR)) {
return;
}
SDL_LockSensors();
if (SDL_updating_sensor) {
/* The sensors are already being updated */
SDL_UnlockSensors();
return;
}
SDL_updating_sensor = SDL_TRUE;
/* Make sure the list is unlocked while dispatching events to prevent application deadlocks */
SDL_UnlockSensors();
for (sensor = SDL_sensors; sensor; sensor = sensor->next) {
sensor->driver->Update(sensor);
}
SDL_LockSensors();
SDL_updating_sensor = SDL_FALSE;
/* If any sensors were closed while updating, free them here */
for (sensor = SDL_sensors; sensor; sensor = sensor->next) {
if (sensor->ref_count <= 0) {
SDL_SensorClose(sensor);
}
}
/* this needs to happen AFTER walking the sensor list above, so that any
dangling hardware data from removed devices can be free'd
*/
for (i = 0; i < SDL_arraysize(SDL_sensor_drivers); ++i) {
SDL_sensor_drivers[i]->Detect();
}
SDL_UnlockSensors();
}

References i, SDL_arraysize, SDL_FALSE, SDL_INIT_SENSOR, SDL_LockSensors(), SDL_sensor_drivers, SDL_SensorClose(), SDL_sensors, SDL_TRUE, SDL_UnlockSensors(), SDL_updating_sensor, and SDL_WasInit.

## SDL_UnlockSensors()

static void SDL_UnlockSensors | ( | void |  | ) |

static

Definition at line 60 of file SDL_sensor.c.

{
if (SDL_sensor_lock) {
SDL_UnlockMutex(SDL_sensor_lock);
}
}

References SDL_sensor_lock, and SDL_UnlockMutex.

Referenced by SDL_NumSensors(), SDL_SensorClose(), SDL_SensorFromInstanceID(), SDL_SensorGetDeviceInstanceID(), SDL_SensorGetDeviceName(), SDL_SensorGetDeviceNonPortableType(), SDL_SensorGetDeviceType(), SDL_SensorOpen(), SDL_SensorQuit(), and SDL_SensorUpdate().

## Variable Documentation

## SDL_next_sensor_instance_id

SDL_atomic_t SDL_next_sensor_instance_id

static

Definition at line 49 of file SDL_sensor.c.

Referenced by SDL_GetNextSensorInstanceID().

## SDL_sensor_drivers

SDL_SensorDriver* SDL_sensor_drivers[]

static

Initial value:
= {
&SDL_DUMMY_SensorDriver
}

Definition at line 35 of file SDL_sensor.c.

Referenced by SDL_GetDriverAndSensorIndex(), SDL_NumSensors(), SDL_SensorInit(), SDL_SensorQuit(), and SDL_SensorUpdate().

## SDL_sensor_lock

SDL_mutex* SDL_sensor_lock = NULL

static

Definition at line 48 of file SDL_sensor.c.

Referenced by SDL_LockSensors(), SDL_SensorInit(), SDL_SensorQuit(), and SDL_UnlockSensors().

## SDL_sensors

SDL_Sensor* SDL_sensors = NULL

static

Definition at line 46 of file SDL_sensor.c.

Referenced by SDL_SensorClose(), SDL_SensorFromInstanceID(), SDL_SensorOpen(), SDL_SensorQuit(), and SDL_SensorUpdate().

## SDL_updating_sensor

SDL_bool SDL_updating_sensor = SDL_FALSE

static

Definition at line 47 of file SDL_sensor.c.

Referenced by SDL_SensorClose(), SDL_SensorQuit(), and SDL_SensorUpdate().

SDL_memset
#define SDL_memset
Definition: SDL_dynapi_overrides.h:386
SDL_updating_sensor
static SDL_bool SDL_updating_sensor
Definition: SDL_sensor.c:47
SDL_LockMutex
#define SDL_LockMutex
Definition: SDL_dynapi_overrides.h:260
NULL
#define NULL
Definition: begin_code.h:167
SDL_DUMMY_SensorDriver
SDL_SensorDriver SDL_DUMMY_SensorDriver
SDL_LockSensors
static void SDL_LockSensors(void)
Definition: SDL_sensor.c:52
SDL_INIT_EVENTS
#define SDL_INIT_EVENTS
Definition: SDL.h:83
SDL_AtomicIncRef
#define SDL_AtomicIncRef(a)
Increment an atomic variable used as a reference count.
Definition: SDL_atomic.h:252
SDL_QuitSubSystem
#define SDL_QuitSubSystem
Definition: SDL_dynapi_overrides.h:56
SDL_CreateMutex
#define SDL_CreateMutex
Definition: SDL_dynapi_overrides.h:259
SDL_ENABLE
#define SDL_ENABLE
Definition: SDL_events.h:759
SDL_GetDriverAndSensorIndex
static SDL_bool SDL_GetDriverAndSensorIndex(int device_index, SDL_SensorDriver **driver, int *driver_index)
Definition: SDL_sensor.c:122
SDL_InitSubSystem
#define SDL_InitSubSystem
Definition: SDL_dynapi_overrides.h:55
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974
SDL_INIT_SENSOR
#define SDL_INIT_SENSOR
Definition: SDL.h:84
SDL_SensorType
SDL_SensorType
Definition: SDL_sensor.h:69
SDL_memcpy
#define SDL_memcpy
Definition: SDL_dynapi_overrides.h:387
event
struct _cl_event * event
Definition: SDL_opengl_glext.h:2649
SDL_FALSE
@ SDL_FALSE
Definition: SDL_stdinc.h:163
SDL_GetEventState
#define SDL_GetEventState(type)
Definition: SDL_events.h:772
SDL_free
#define SDL_free
Definition: SDL_dynapi_overrides.h:377
SDL_SENSORUPDATE
@ SDL_SENSORUPDATE
Definition: SDL_events.h:151
SDL_PushEvent
#define SDL_PushEvent
Definition: SDL_dynapi_overrides.h:125
name
GLuint const GLchar * name
Definition: SDL_opengl_glext.h:660
SDL_min
#define SDL_min(x, y)
Definition: SDL_stdinc.h:406
SDL_JOYAXISMOTION
@ SDL_JOYAXISMOTION
Definition: SDL_events.h:111
SDL_SENSOR_INVALID
@ SDL_SENSOR_INVALID
Definition: SDL_sensor.h:71
SDL_assert
#define SDL_assert(condition)
Definition: SDL_assert.h:169
SDL_OutOfMemory
#define SDL_OutOfMemory()
Definition: SDL_error.h:52
SDL_sensor_drivers
static SDL_SensorDriver * SDL_sensor_drivers[]
Definition: SDL_sensor.c:35
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:115
SDL_calloc
#define SDL_calloc
Definition: SDL_dynapi_overrides.h:375
SDL_TRUE
@ SDL_TRUE
Definition: SDL_stdinc.h:164
SDL_next_sensor_instance_id
static SDL_atomic_t SDL_next_sensor_instance_id
Definition: SDL_sensor.c:49
SDL_SensorClose
void SDL_SensorClose(SDL_Sensor *sensor)
Definition: SDL_sensor.c:390
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_sensors
static SDL_Sensor * SDL_sensors
Definition: SDL_sensor.c:46
SDL_PrivateSensorValid
static int SDL_PrivateSensorValid(SDL_Sensor *sensor)
Definition: SDL_sensor.c:305
SDL_DestroyMutex
#define SDL_DestroyMutex
Definition: SDL_dynapi_overrides.h:263
SDL_strdup
#define SDL_strdup
Definition: SDL_dynapi_overrides.h:397
SDL_sensor_lock
static SDL_mutex * SDL_sensor_lock
Definition: SDL_sensor.c:48
SDL_Event
General event structure.
Definition: SDL_events.h:557
SDL_UnlockMutex
#define SDL_UnlockMutex
Definition: SDL_dynapi_overrides.h:262
SDL_WasInit
#define SDL_WasInit
Definition: SDL_dynapi_overrides.h:57
type
GLuint GLuint GLsizei GLenum type
Definition: SDL_opengl.h:1571
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_UnlockSensors
static void SDL_UnlockSensors(void)
Definition: SDL_sensor.c:60
SDL_SensorID
Sint32 SDL_SensorID
Definition: SDL_sensor.h:60